<?php
/*
Plugin Name: DailyFratze Widget
Description: Adds a fratze to your sidebar
Author: Michael Simons
Version: 0.3
Author URI: http://michael-simons.eu
*/

function dailyfratze_latest_fratze() {
    dailyfratze_private_doit(get_option('widget_dailyfratze'));
}

function widget_dailyfratze_init() {
	function widget_dailyfratze($args) {
		extract($args);
                		
        $options = get_option('widget_dailyfratze');
        $title   = $options['title'];			  	
        echo $before_widget . $before_title . $title . $after_title;
        dailyfratze_private_doit($options);
        echo $after_widget;		
	}

	function widget_dailyfratze_control() {
		$options = get_option('widget_dailyfratze');
		if ( !is_array($options) )
			$options = array('title'=>'', 'fratzenschneider'=>'', 'size'=>'small', 'width'=>'');
		if ( $_POST['dailyfratze-submit'] ) {
			dailyfratze_private_retrive_option_input($options);
		}		
						
		dailyfratze_private_echo_option_input($options);
	}
	
	register_sidebar_widget(array('DailyFratze.de', 'widgets'), 'widget_dailyfratze');		
	register_widget_control(array('DailyFratze.de', 'widgets'), 'widget_dailyfratze_control', 300, 150);
}

function plugin_dailyfratze_options() {
	if (function_exists('add_options_page')) {
    	add_options_page('DailyFratze.de', 'DailyFratze.de', 0, basename(__FILE__), 'dailyfratze_private_options_subpanel');
	}
}

function dailyfratze_private_echo_option_input($options) {
    $title            = htmlspecialchars($options['title'], ENT_QUOTES);
	$fratzenschneider = htmlspecialchars($options['fratzenschneider'], ENT_QUOTES);
    $size             = htmlspecialchars($options['size'], ENT_QUOTES);
    $width            = htmlspecialchars($options['width'], ENT_QUOTES);
	?>
	<table>
		<tr>
			<td><label for="dailyfratze-title">Titel</label></td>
			<td><input style="width: 200px;" id="dailyfratze-title" name="dailyfratze-title" type="text" title="Only used for the widget" value="<?php echo $title ; ?>" /></td>
		</tr>
		<tr>
			<td><label for="dailyfratze-fratzenschneider">Fratze</label></td>
			<td><input style="width: 200px;" id="dailyfratze-fratzenschneider" name="dailyfratze-fratzenschneider" type="text" value="<?php echo $fratzenschneider; ?>" /></td>
		</tr>
		<tr>
			<td><label for="dailyfratze-size"><?php echo __('Originalsize'); ?></label></td>
			<td>
				<select name="dailyfratze-size">
					<option value="small" <?php echo $size == 'small' ? 'selected="selected"' : ''; ?>><?php echo __('Small'); ?></option>
					<option value="big"   <?php echo $size == 'big'   ? 'selected="selected"' : ''; ?>><?php echo __('Big'); ?></option>
	    	</select>
			</td>
		</tr>
		<tr>
			<td><label for="dailyfratze-width">Imagewidth</label></td>
			<td><input style="width: 200px;" id="dailyfratze-width" name="dailyfratze-width" type="text" value="<?php echo $width; ?>" /></td>
		</tr>
	</table>
	<?php 
	echo '<input type="hidden" id="dailyfratze-submit" name="dailyfratze-submit" value="1" />';
}

function dailyfratze_private_retrive_option_input($options) {
	$options['title']            = strip_tags(stripslashes($_POST['dailyfratze-title']));			
	$options['fratzenschneider'] = strip_tags(stripslashes($_POST['dailyfratze-fratzenschneider']));			
	$options['size']             = strip_tags(stripslashes($_POST['dailyfratze-size']));
	$options['width']             = strip_tags(stripslashes($_POST['dailyfratze-width']));
	update_option('widget_dailyfratze', $options);                
}

function dailyfratze_private_doit($options) {        
    set_magic_quotes_runtime(0);
    require_once(ABSPATH . WPINC . '/rss.php');
    define('MAGPIE_CACHE_ON',  true);			
    $fratzenschneider = $options['fratzenschneider'];			               
	$width            = $options['width'];	
    $fratzen = fetch_rss("http://dailyfratze.de/feeds/fratzen/" . $fratzenschneider . "/feed.xml");	
    foreach ($fratzen->items as $item) 
	    $pics[] = array(
	                'big' => $item['link_image_big'], 
	                'small' => $item['link_image_small'],
	                'title' => $item['title'],
	                'id'    => substr($item['id'], 0, strrpos($item['id'], '/'))
	              );							
    $i = 0;
    $fname = $pics[$i][$options['size'] == '' || $options['size'] == null ? 'small' : $options['size']];
    
    echo '<a href="' . $pics[$i]['id']. '">';		
	echo '<img src="data:image/jpeg;base64,' . base64_encode(file_get_contents($fname)) . '" alt="'. $pics[$i]['title']  .'" title="' .$pics[$i]['title'] . '"' . ($width != '' ? 'width="' . $width . '" ' : '') .   '/>';
	echo '</a>';
}

function dailyfratze_private_options_subpanel() {
    $options = get_option('widget_dailyfratze');
	if ( !is_array($options) )
		$options = array('title'=>'', 'fratzenschneider'=>'', 'size'=>'small', 'width'=>'');   
    if (isset($_POST['info_update'])) {
        ?><div class="updated"><p><strong><?php 
		dailyfratze_private_retrive_option_input(&$options);
        _e('Done.');
        ?></strong></p></div><?php
    } ?>
    
    <div class=wrap>
    <form method="post">
        <h2>DailyFratze Options</h2>
        <fieldset name="set1">
        <?php dailyfratze_private_echo_option_input($options); ?>
        </fieldset>     
        <div class="submit">
            <input type="submit" name="info_update" value="<?php
            _e('Update options')
            ?>" /></div>
    </form>
    </div><?php
}

add_action('widgets_init', 'widget_dailyfratze_init');
add_action('admin_menu', 'plugin_dailyfratze_options');
?>